package cx.ath.jbzdak.wyklad1.table;

import java.io.*;
import java.util.Arrays;
import java.util.List;

/**
 * Created by: Jacek Bzdak
 */
public class Database {
   
   public static final String STUDENTS_FILE = ".students.ser"; 



   public static List<Student> getStudentsFromDatabase(){
      try {
         return readStudents();
      } catch (IOException e) {
         System.out.println("Nie udało się odczytać listy studentów --- zwracam domyślną ");
      }
      return Arrays.asList(
              new Student("Jacek", "Bzdak", 2.5),
              new Student("Jan", "Kowalski", 3.5),
              new Student("Alojzy", "Kleks", 5.3)
      );
   }
   

   public static void saveToDatabase(List<Student> students) throws IOException{
      ObjectOutputStream outputStream = new ObjectOutputStream(new FileOutputStream(STUDENTS_FILE));
      try{
         outputStream.writeObject(students);
      }finally {
         outputStream.close();
      }
   }
   
   private static List<Student> readStudents() throws IOException{
      ObjectInputStream inputStream = new ObjectInputStream(new FileInputStream(STUDENTS_FILE));
      try {
         return (List<Student>) inputStream.readObject();
      } catch (ClassNotFoundException e) {
         throw new IOException("Coulnd't load students", e);
      }finally {
         inputStream.close();
      }
   }

}
