package cx.ath.jbzdak.wyklad1.table;

import javax.swing.table.AbstractTableModel;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

class StudentsModel extends AbstractTableModel {

   List<Student> list = new ArrayList<Student>();


   public void addStudent(Student student){
      list.add(student);
      fireTableDataChanged(); // To jest nie bardzo eleganckie, ale daje radę. Lepiej byłoby wysyłać informacje
      // o dokładnie tym obiekcie który się zmienił
   }

   public void addStudents(Collection<Student> students){
      list.addAll(students);
      fireTableDataChanged();    // To jest nie bardzo eleganckie, ale daje radę. Lepiej byłoby wysyłać informacje
      // o dokładnie tym obiekcie który się zmienił
   }

   public List<Student> getList() {
      return list;
   }

   public int getRowCount() {
      return list.size();
   }

   public int getColumnCount() {
      return 4;
   }

   @Override
   public boolean isCellEditable(int rowIndex, int columnIndex) {
      return true;
   }

   @Override
   public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
      switch (columnIndex){
         case 0:
            list.get(rowIndex).setName(String.valueOf(aValue));
            break;
         case 1:
            list.get(rowIndex).setSurname(String.valueOf(aValue));
            break;
         case 2:
            list.get(rowIndex).setMark((Double) aValue);
            break;
         case 3:
            list.get(rowIndex).setLikesJava((Boolean) aValue);
            break;
         default:
            throw new IllegalStateException();
      }
   }

   @Override
   public Class<?> getColumnClass(int columnIndex) {
      if (columnIndex == 3){
         return Boolean.class;
      }
      if (columnIndex == 2){
         return Double.class;
      }
      return Object.class;
   }

   public Object getValueAt(int rowIndex, int columnIndex) {
      switch (columnIndex){
         case 0:
            return list.get(rowIndex).getName();
         case 1:
            return list.get(rowIndex).getSurname();
         case 2:
            return list.get(rowIndex).getMark();
         case 3:
            return list.get(rowIndex).getLikesJava();
         default:
            throw new IllegalStateException();
      }
   }

   @Override
   public String getColumnName(int column) {
      switch (column){
         case 0:
            return "Imię";
         case 1:
            return "Nazwisko";
         case 2:
            return "Ocena";
         case 3:
            return "Czy lubi javę";
         default:
            throw new IllegalStateException();
      }
   }
}