package cx.ath.jbzdak.wyklad1.table;

import javax.swing.*;
import javax.swing.table.TableRowSorter;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Created by: Jacek Bzdak
 */
public class TableFrame5 extends TableFrame4{

   private final TableRowSorter<StudentsModel> rowSorter;

   public TableFrame5() throws HeadlessException {

      rowSorter = new TableRowSorter<StudentsModel>((StudentsModel) table.getModel());
      table.setRowSorter(rowSorter);
      
      JPanel filterPanel = new JPanel();

      filterPanel.setLayout(new FlowLayout());

      add(filterPanel, BorderLayout.NORTH);
      
      final JTextField nameFilterField = new JTextField();
      
      nameFilterField.setColumns(12);

      ActionListener l = new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            if ("".equals(nameFilterField.getText().trim())) {
               rowSorter.setRowFilter(null);
               return;
            }
            rowSorter.setRowFilter(new RowFilter<StudentsModel, Integer>() {
               @Override
               public boolean include(Entry<? extends StudentsModel, ? extends Integer> entry) {
                  Student student = entry.getModel().getList().get(entry.getIdentifier());
                  String name = student.getName();
                  String surname = student.getSurname();

                  if (name != null && name.contains(nameFilterField.getText())) {
                     return true;
                  }

                  if (surname != null && surname.contains(nameFilterField.getText())) {
                     return true;
                  }

                  return false;
               }
            });
         }
      };
      
      nameFilterField.addActionListener(l);
      
      final JComboBox likesJava = new JComboBox(new Object[]{"----", "lubi", "nie lubi", "nie wiadomo"});
      
      likesJava.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            if ("----".equals(likesJava.getSelectedItem())) {
               rowSorter.setRowFilter(null);
               return;
            }
            
            rowSorter.setRowFilter(new RowFilter<StudentsModel, Integer>() {
               @Override
               public boolean include(Entry<? extends StudentsModel, ? extends Integer> entry) {
                  Student student = entry.getModel().getList().get(entry.getIdentifier());
                  if(likesJava.getSelectedIndex() == 1){
                     return student.getLikesJava() == Boolean.TRUE;                                         
                  }
                  if(likesJava.getSelectedIndex() == 2){
                     return student.getLikesJava() == Boolean.FALSE;
                  }
                  if(likesJava.getSelectedIndex() == 3){
                     return student.getLikesJava() == null;
                  }
                  throw  new IllegalStateException();
               }
            });
         }
      });

      filterPanel.add(nameFilterField);
      filterPanel.add(likesJava);
   }


   public static void main(String[] args) throws Exception{
      SwingUtilities.invokeLater(new Runnable() {
         public void run() {
            TableFrame5 tf = new TableFrame5();
            tf.setSize(640, 480);
            tf.setVisible(true);
         }
      });
   }
}


