package cx.ath.jbzdak.wyklad2.x01innerClass;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Created by: Jacek Bzdak
 */
public class InnerClassListener extends ListenerShowcaseBase{

   public InnerClassListener() throws HeadlessException {
      button1.addActionListener(new InternalListener(Color.GREEN));
      button2.addActionListener(new InternalListener(Color.RED));
   }
   
   class InternalListener implements ActionListener{

      final Color color;

      InternalListener(Color color) {
         this.color = color;
      }

      public void actionPerformed(ActionEvent e) {
         /**Wskaźnik na this z klasy InnerClassListener został autpomatycznie przekazany do instancji
          InternalListener.

          Dodatkowo nie musimy korzystać z InnerClassListener.this, tj. w tym przypadku samo getContentPane też
          by zadziałało.

          */
         InnerClassListener.this.getContentPane().setBackground(color);
//         getContentPane().setBackground(color);
      }
   }

   public static void main(String[] args) {
      SwingUtilities.invokeLater(new Runnable() {
         public void run() {
            InnerClassListener frame = new InnerClassListener();
            frame.setVisible(true);
         }
      });
   }
}
