package cx.ath.jbzdak.wyklad2.x02action;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;

/**
 * Created by: Jacek Bzdak
 */
public class ActionFrame extends JFrame{

   public ActionFrame() throws HeadlessException {

      setSize(200, 300);

      setDefaultCloseOperation(DISPOSE_ON_CLOSE);

      //Tworzymy dwie akcje. Te akcje będą wielokronnie wykorzystywane!
      Action redAction = new MyAction("Ustaw na czerwone", Color.RED, this);

      Action blueAction = new MyAction("Ustaw na niebieskie", Color.BLUE, this);
      
      setLayout(new FlowLayout());

      // Na podstawie akcji można stworzyć guzik
      add(new JButton(redAction));
      add(new JButton(blueAction));

      // Albo pozycję w menu!
      JMenuItem redItem = new JMenuItem(redAction);
      JMenuItem blueItem = new JMenuItem(blueAction);

      redItem.setAccelerator(KeyStroke.getKeyStroke("control R"));

      JMenuBar menuBar =  new JMenuBar();

      setJMenuBar(menuBar);

      JMenu menu = new JMenu("Akcje");

      menuBar.add(menu);

      menu.add(redItem);
      menu.add(blueItem);

      pack();

   }

   public static void main(String[] args) {
      SwingUtilities.invokeLater(new Runnable() {
         public void run() {
            ActionFrame frame = new ActionFrame();
            frame.setVisible(true);
         }
      });
   }
  
}

class MyAction extends AbstractAction{

   final Color color;

   final JFrame parent;

   MyAction(Color color, JFrame parent) {
      this.color = color;
      this.parent = parent;
   }

   MyAction(String name, Color color, JFrame parent) {
      super(name);
      this.color = color;
      this.parent = parent;
   }



   public void actionPerformed(ActionEvent e) {
      parent.getContentPane().setBackground(color);
   }
}