package laboratoria.lab3.jlist;

import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import java.awt.*;

/**
 * Created by: Jacek Bzdak
 */
public class JListFrame extends JFrame{

   public JListFrame() throws HeadlessException {

      final Object[] listData = {"A", "B", "C", "D", "E", "F"}; /// Dane do listy. To jest tablica obiektów bo
      // konstruktor JListy oczekuję właśnie tablicy obiektów a String[] nie dałaby rady.

      final JList list = new JList(listData);

      list.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION); // Definiuje jak możemy ustawić własności
      // listy. Proszę poczytać o tym jak działają stałe.

      list.addListSelectionListener(new ListSelectionListener() {
         public void valueChanged(ListSelectionEvent e) {
            System.out.println("NEW SELECTION");
            if (!e.getValueIsAdjusting()){ //Jeśli false to znaczy że wybór jest ostateczny, jeśli getValueIsAdjusting()
//               zwraca true znaczy to że dana wartosć 'jest w trakcie zmieniania'.
               for (int index : list.getSelectedIndices()){
                  System.out.println("Selected " + listData[index]);
               }
            }
         }
      });

      add(list); // Dodaje liste do kontenera
   }

   public static void main(String[] args) throws Exception{
      SwingUtilities.invokeLater(new Runnable() {
         public void run() {
            JListFrame tf = new JListFrame();
            tf.setSize(640, 480);
            tf.setVisible(true);
         }
      });
   }
}
