package laboratoria.lab3.rozszerzone;

import java.io.*;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by: Jacek Bzdak
 */
public class Database implements Serializable{

   private static final long serialVersionUID = 42L;

   public static String FILE_NAME = ".database.ser";

   private List<Student> students = new ArrayList<Student>();
   
   private List<Mark> marks = new ArrayList<Mark>();

   private List<Course> courses = new ArrayList<Course>();

   public List<Student> getStudents() {
      return students;
   }

   public List<Mark> getMarks() {
      return marks;
   }

   public List<Course> getCourses() {
      return courses;
   }

   public void save() throws IOException {

      ObjectOutputStream outputStream = new ObjectOutputStream(new FileOutputStream(FILE_NAME));
      try{
        outputStream.writeObject(this);
      }finally {
         outputStream.close();
      }

   }

   public void load() throws IOException, ClassNotFoundException {
      ObjectInputStream inputStream = new ObjectInputStream(new FileInputStream(FILE_NAME));
      try{
         Database read = (Database) inputStream.readObject();
         students.addAll(read.getStudents());
         marks.addAll(read.getMarks());
         courses.addAll(read.getCourses());
      }finally {
         inputStream.close();
      }

   }
}
